<template>
  <div class="container">
    <!-- 查询配置 -->
    <div style="padding: 0px 20px">
      <div ref="lxHeader">
        <LxHeader icon="md-apps" text="字典数据" style="margin-bottom: 10px; border: 0px; margin-top: 15px">
          <div slot="content"></div>
          <slot>
            <div>
              <Button type="primary" @click="load">查询</Button>
              <Button type="primary" @click="edit()" style="margin-left: 10px">新增字典</Button>
            </div>
          </slot>
        </LxHeader>
      </div>
      <div class="table-tree">
        <el-table :data="tableData" :height="tableHeight" class="v-table" style="width: 100%;margin-bottom: 20px;"
          row-key="id" border default-expand-all :tree-props="{children: 'children', hasChildren: 'hasChildren'}">
          <el-table-column type="index" align="center">
          </el-table-column>
          <el-table-column prop="number" label="字典编码" sortable width="180">
          </el-table-column>
          <el-table-column prop="name" label="字典名称" sortable width="220">
          </el-table-column>
          <el-table-column prop="remark" label="备注" sortable>
          </el-table-column>
          <el-table-column prop="sort" align="center" label="排序" sortable width="80">
          </el-table-column>
          <el-table-column fixed="right" label="操作" width="300">
            <template slot-scope="scope">
              <Button type="primary" @click="addchildren(scope.row)" size="small" style="margin-left: 10px;"
                ghost>下一级</Button>
              <Button type="error" @click="del(scope.row)" size="small" style="margin-left: 10px;" ghost>删除</Button>
              <Button type="primary" @click="edit(scope.row)" size="small" style="margin-left: 10px;" ghost>编辑</Button>
            </template>
          </el-table-column>
        </el-table>
      </div>
    </div>

    <el-dialog title="字典编辑" :visible.sync="dialogFormVisible" width="80%">
      <el-form :model="form" :rules="rules" ref="form" label-position="right" :label-width="formLabelWidth">
        <el-row :gutter="20">
          <el-col :span="24">
            <el-form-item label="上级">
              <el-input v-model="form.pname" disabled autocomplete="off"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="字典编码" prop="number">
              <el-input v-model="form.number" autocomplete="off"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="字典名称" prop="name">
              <el-input v-model="form.name" autocomplete="off"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="是否启用" prop="status">
              <el-select v-model="form.status">
                <el-option label="启用" value="1"></el-option>
                <el-option label="不启用" value="0"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="排序">
              <el-input v-model="form.sort" autocomplete="off"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="备注">
              <el-input v-model="form.remark" type="textarea" autocomplete="off"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <div class="table-tree">
          <div style="display: flex;justify-content: flex-end;margin-right: 20px;margin-bottom: 10px;">
            <Button type="primary" @click="addRow()" size="small" style="margin-left: 10px;" ghost>新增参数</Button>
          </div>
          <el-table :data="this.form.detail_list" height="400" class="v-table" style="width: 100%;margin-bottom: 20px;">
            <el-table-column type="index" align="center">
            </el-table-column>
            <el-table-column prop="id" align="center" label="主健ID" width="120">
            </el-table-column>
            <el-table-column prop="value" label="数据值Text" width="320">
              <template slot-scope="scope">
                <el-input v-model="scope.row.value" />
                </el-input>
              </template>
            </el-table-column>
            <el-table-column prop="sort" align="center" label="排序" width="80">
              <template slot-scope="scope">
                <el-input v-model="scope.row.sort" />
                </el-input>
              </template>
            </el-table-column>
            <el-table-column prop="status" align="center" label="状态" width="180">
              <template slot-scope="scope">
                <el-switch v-model="scope.row.status" />
                </el-switch>
              </template>
            </el-table-column>
            <el-table-column prop="remark" label="备注">
              <template slot-scope="scope">
                <el-input v-model="scope.row.remark" />
                </el-input>
              </template>
            </el-table-column>
            <el-table-column label="操作" width="100" align="center">
              <template slot-scope="scope">
                <Button type="error" @click="delRow(scope.row,scope.$index)" size="small" style="margin-left: 10px;"
                  ghost>删除</Button>
              </template>
            </el-table-column>
          </el-table>
        </div>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="resetForm('form')">取 消</el-button>
        <el-button type="primary" @click="submitForm('form')">确 定</el-button>
      </div>
    </el-dialog>

  </div>
</template>
<script>
  import LxHeader from "@/components/LxHeader/index.vue";
  import {
    save,
    listparameter,
    del,
    store,
    getparameter,
    delDetail
  } from "../../api/system/dictionary.js";
  export default {
    components: {
      LxHeader
    },
    created() {
      this.initLoad();
      this.load();
    },
    mounted() {},
    data() {
      return {
        dialogFormVisible: false,
        formLabelWidth: "120px",
        form: {
          pname: "根级别",
          number: "",
          id: "",
          pid: "0",
          name: "",
          status: "1",
          sort: 0,
          remark: "",
          detail_list: [{
            id: "",
            value: "",
            sort: "1",
            status: true,
            remark: ""
          }]
        },
        rules: {
          name: [{
            required: true,
            message: '请输入菜单名称',
            trigger: 'blur'
          }],
          url: [{
            required: true,
            message: '请输入菜单路径',
            trigger: 'blur'
          }],
          visible: [{
            required: true,
            message: '请选择是否显示',
            trigger: 'blur'
          }],
        },
        tableHeight: 0,
        //查询条件字段
        searchFields: {
          KeyWord: ""
        },
        tableData: []
      }
    },
    methods: {
      addRow() {
        var len = this.form.detail_list.length;
        this.form.detail_list.push({
          value: "",
          sort: len + 1,
          status: true,
          remark: ""
        })
      },
      delRow(obj, index) {
        if (obj.id) {
          delDetail(obj.id).then(response => {

            this.$message.success("操作成功");
            this.form.detail_list.splice(index, 1);
          }).catch(error => {
            //reject(error)
            this.$message.error("操作失败");
          })
        } else {
          this.form.detail_list.splice(index, 1);
        }


      },
      initLoad() {
        var that = this;
        var clientHeight = document.documentElement.clientHeight
        var lxHeader_height = 96.5; //查询 头部
        var paginationHeight = 37; //分页的高度
        var topHeight = 50; //页面 头部
        let tableHeight = clientHeight - lxHeader_height - topHeight - paginationHeight - 20;
        that.tableHeight = tableHeight;
      },
      load() {
        var that = this;
        listparameter().then(response => {
          that.tableData = response.data;
        }).catch(error => {
          //reject(error)
        })

      },
      show(obj) {
        this.clientHeight = document.documentElement.clientHeight - 84 - 110;
        this.dialogViewVisible = true;
        this.info(obj);
      },
      info(obj) {
        var that = this;
        getparameter({
          id: obj.id
        }).then(response => {
          for (var m of response.detail) {
            m.status = m.status == 1;
          }
          response.detail_list = response.detail;
          let result = Object.assign(that.form, response);
          that.form.status = result.status.toString();
        }).catch(error => {
          //reject(error)
        })
      },
      edit(obj) {
        this.form = this.$options.data().form;
        this.clientHeight = document.documentElement.clientHeight - 84 - 110;
        if (obj) {
          var that = this;
          that.info(obj);
        } else {}
        this.dialogFormVisible = true;
      },
      addchildren(obj) {
        this.form = this.$options.data().form
        if (obj) {
          this.form.pname = obj.name;
          this.form.pid = obj.id;
          this.dialogFormVisible = true;
        }
      },
      submitForm(formName) {
        var that = this;
        this.$refs[formName].validate((valid) => {
          if (valid) {
            if (that.form.id) {
              save(that.form).then(response => {
                console.log(response)
                this.$Message.success('操作成功');
                that.dialogFormVisible = false;
                that.load();
              }).catch(error => {})
            } else {
              store(that.form).then(response => {
                console.log(response)
                this.$Message.success('操作成功');
                that.dialogFormVisible = false;
                that.load();
              }).catch(error => {})
            }

          } else {
            this.$Message.error('数据校验失败');
            return false;
          }
        });
      },
      resetForm(formName) {
        var that = this;
        this.$refs[formName].resetFields();
        that.dialogFormVisible = false;
      },
      del(obj) {
        var that = this;
        if (obj) {
          this.$Modal.confirm({
            title: '确认要删除数据？',
            onOk: () => {
              del(obj.id).then(response => {
                this.$Message.success('操作成功');
                that.load();
              }).catch(error => {
                console.log(error)
                reject(error)
              })
            },
            onCancel: () => {
              //this.$Message.info('Clicked cancel');
            }
          });
        }
      },
    }
  };
</script>
